> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Angular Integration

> CometChat Calling SDK v5 - Angular Integration for JavaScript

This guide walks you through integrating the CometChat Calls SDK into an Angular application. By the end, you'll have a working video call implementation with proper service architecture and lifecycle management.

## Prerequisites

Before you begin, ensure you have:

* A CometChat account with an app created ([Sign up](https://app.cometchat.com/signup))
* Your App ID, Region, and API Key from the CometChat Dashboard
* An Angular 14+ project
* Node.js 16+ installed

## Step 1: Install the SDK

Install the CometChat Calls SDK package:

```bash theme={null}
npm install @cometchat/calls-sdk-javascript
```

## Step 2: Create the Calls Service

Create a service to manage SDK initialization, authentication, and call operations:

```typescript theme={null}
// src/app/services/cometchat-calls.service.ts
import { Injectable } from "@angular/core";
import { CometChatCalls } from "@cometchat/calls-sdk-javascript";
import { BehaviorSubject, Observable } from "rxjs";

interface User {
  uid: string;
  name: string;
  avatar?: string;
}

@Injectable({
  providedIn: "root",
})
export class CometChatCallsService {
  private readonly APP_ID = "YOUR_APP_ID";       // Replace with your App ID
  private readonly REGION = "YOUR_REGION";       // Replace with your Region
  private readonly API_KEY = "YOUR_API_KEY";     // Replace with your API Key

  // Observable state
  private isReadySubject = new BehaviorSubject<boolean>(false);
  private userSubject = new BehaviorSubject<User | null>(null);
  private errorSubject = new BehaviorSubject<string | null>(null);

  isReady$: Observable<boolean> = this.isReadySubject.asObservable();
  user$: Observable<User | null> = this.userSubject.asObservable();
  error$: Observable<string | null> = this.errorSubject.asObservable();

  /**
   * Initialize the SDK and login the user.
   * Call this once when your app starts.
   */
  async initAndLogin(uid: string): Promise<void> {
    if (this.isReadySubject.value) return;

    try {
      // Step 1: Initialize the SDK
      const initResult = await CometChatCalls.init({
        appId: this.APP_ID,
        region: this.REGION,
      });

      if (!initResult.success) {
        throw new Error("SDK initialization failed");
      }

      // Step 2: Check if already logged in
      let loggedInUser = CometChatCalls.getLoggedInUser();

      // Step 3: Login if not already logged in
      if (!loggedInUser) {
        loggedInUser = await CometChatCalls.login(uid, this.API_KEY);
      }

      this.userSubject.next(loggedInUser as User);
      this.isReadySubject.next(true);
      this.errorSubject.next(null);
    } catch (err: any) {
      console.error("CometChat Calls setup failed:", err);
      this.errorSubject.next(err.message || "Setup failed");
    }
  }

  /**
   * Logout the current user.
   */
  async logout(): Promise<void> {
    try {
      await CometChatCalls.logout();
      this.userSubject.next(null);
      this.isReadySubject.next(false);
    } catch (err) {
      console.error("Logout failed:", err);
    }
  }

  /**
   * Generate a call token for a session.
   */
  async generateToken(sessionId: string): Promise<{ token: string }> {
    return CometChatCalls.generateToken(sessionId);
  }

  /**
   * Join a call session.
   */
  async joinSession(
    token: string,
    settings: any,
    container: HTMLElement
  ): Promise<any> {
    return CometChatCalls.joinSession(token, settings, container);
  }

  /**
   * Leave the current call session.
   */
  leaveSession(): void {
    CometChatCalls.leaveSession();
  }

  /**
   * Add an event listener.
   * Returns an unsubscribe function.
   */
  addEventListener(event: string, callback: Function): () => void {
    return CometChatCalls.addEventListener(event as any, callback as any);
  }

  // Audio controls
  muteAudio(): void {
    CometChatCalls.muteAudio();
  }

  unMuteAudio(): void {
    CometChatCalls.unMuteAudio();
  }

  // Video controls
  pauseVideo(): void {
    CometChatCalls.pauseVideo();
  }

  resumeVideo(): void {
    CometChatCalls.resumeVideo();
  }
}
```

## Step 3: Initialize in App Component

Initialize the SDK when your app starts:

```typescript theme={null}
// src/app/app.component.ts
import { Component, OnInit } from "@angular/core";
import { CometChatCallsService } from "./services/cometchat-calls.service";
import { Observable } from "rxjs";

@Component({
  selector: "app-root",
  template: `
    <div *ngIf="error$ | async as error" class="error">
      Error: {{ error }}
    </div>
    <div *ngIf="!(isReady$ | async) && !(error$ | async)" class="loading">
      Loading...
    </div>
    <router-outlet *ngIf="isReady$ | async"></router-outlet>
  `,
})
export class AppComponent implements OnInit {
  isReady$: Observable<boolean>;
  error$: Observable<string | null>;

  constructor(private callsService: CometChatCallsService) {
    this.isReady$ = this.callsService.isReady$;
    this.error$ = this.callsService.error$;
  }

  ngOnInit(): void {
    // In a real app, get this from your authentication system
    const currentUserId = "cometchat-uid-1";
    this.callsService.initAndLogin(currentUserId);
  }
}
```

## Step 4: Create the Call Component

Build a call component with proper lifecycle management:

```typescript theme={null}
// src/app/components/call-screen/call-screen.component.ts
import {
  Component,
  Input,
  Output,
  EventEmitter,
  OnInit,
  OnDestroy,
  ViewChild,
  ElementRef,
} from "@angular/core";
import { CometChatCallsService } from "../../services/cometchat-calls.service";

@Component({
  selector: "app-call-screen",
  template: `
    <div class="call-screen">
      <!-- Video container - SDK renders the call UI here -->
      <div #callContainer class="call-container"></div>

      <!-- Loading overlay -->
      <div *ngIf="isJoining" class="call-overlay">
        Joining call...
      </div>

      <!-- Error message -->
      <div *ngIf="callError" class="call-overlay error">
        <p>Error: {{ callError }}</p>
        <button (click)="callEnded.emit()">Go Back</button>
      </div>

      <!-- Call controls -->
      <div *ngIf="isJoined" class="call-controls">
        <button
          (click)="toggleAudio()"
          [class.muted]="isMuted"
          [class.active]="!isMuted"
        >
          {{ isMuted ? "Unmute" : "Mute" }}
        </button>
        <button
          (click)="toggleVideo()"
          [class.muted]="isVideoOff"
          [class.active]="!isVideoOff"
        >
          {{ isVideoOff ? "Start Video" : "Stop Video" }}
        </button>
        <button (click)="leaveCall()" class="leave-btn">
          Leave Call
        </button>
      </div>
    </div>
  `,
  styles: [
    `
      .call-screen {
        display: flex;
        flex-direction: column;
        height: 100vh;
        position: relative;
      }
      .call-container {
        flex: 1;
        background-color: #1a1a1a;
        min-height: 400px;
      }
      .call-controls {
        display: flex;
        justify-content: center;
        gap: 12px;
        padding: 16px;
        background-color: #2a2a2a;
      }
      .call-controls button {
        padding: 12px 24px;
        border: none;
        border-radius: 8px;
        font-size: 14px;
        cursor: pointer;
      }
      .call-controls button.active {
        background-color: #28a745;
        color: white;
      }
      .call-controls button.muted {
        background-color: #dc3545;
        color: white;
      }
      .call-controls .leave-btn {
        background-color: #dc3545;
        color: white;
      }
      .call-overlay {
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        background: rgba(0, 0, 0, 0.8);
        color: white;
        padding: 20px;
        border-radius: 8px;
        text-align: center;
      }
    `,
  ],
})
export class CallScreenComponent implements OnInit, OnDestroy {
  @Input() sessionId!: string;
  @Output() callEnded = new EventEmitter<void>();
  @ViewChild("callContainer", { static: true }) callContainer!: ElementRef;

  isJoined = false;
  isJoining = false;
  isMuted = false;
  isVideoOff = false;
  callError: string | null = null;

  private unsubscribers: (() => void)[] = [];

  constructor(private callsService: CometChatCallsService) {}

  ngOnInit(): void {
    this.joinCall();
  }

  ngOnDestroy(): void {
    this.cleanup();
  }

  /**
   * Join the call session.
   */
  private async joinCall(): Promise<void> {
    this.isJoining = true;
    this.callError = null;

    try {
      // Register event listeners before joining
      this.unsubscribers = [
        this.callsService.addEventListener("onSessionJoined", () => {
          this.isJoined = true;
          this.isJoining = false;
        }),
        this.callsService.addEventListener("onSessionLeft", () => {
          this.isJoined = false;
          this.callEnded.emit();
        }),
        this.callsService.addEventListener("onAudioMuted", () => {
          this.isMuted = true;
        }),
        this.callsService.addEventListener("onAudioUnMuted", () => {
          this.isMuted = false;
        }),
        this.callsService.addEventListener("onVideoPaused", () => {
          this.isVideoOff = true;
        }),
        this.callsService.addEventListener("onVideoResumed", () => {
          this.isVideoOff = false;
        }),
      ];

      // Generate a call token for this session
      const tokenResult = await this.callsService.generateToken(this.sessionId);

      // Join the call session
      const joinResult = await this.callsService.joinSession(
        tokenResult.token,
        {
          sessionType: "VIDEO",
          layout: "TILE",
          startAudioMuted: false,
          startVideoPaused: false,
        },
        this.callContainer.nativeElement
      );

      if (joinResult.error) {
        throw new Error(joinResult.error.message);
      }
    } catch (err: any) {
      console.error("Failed to join call:", err);
      this.callError = err.message || "Failed to join call";
      this.isJoining = false;
    }
  }

  /**
   * Toggle microphone mute state.
   */
  toggleAudio(): void {
    if (this.isMuted) {
      this.callsService.unMuteAudio();
    } else {
      this.callsService.muteAudio();
    }
  }

  /**
   * Toggle camera on/off state.
   */
  toggleVideo(): void {
    if (this.isVideoOff) {
      this.callsService.resumeVideo();
    } else {
      this.callsService.pauseVideo();
    }
  }

  /**
   * Leave the current call session.
   */
  leaveCall(): void {
    this.callsService.leaveSession();
  }

  /**
   * Cleanup event listeners.
   */
  private cleanup(): void {
    this.unsubscribers.forEach((unsub) => unsub());
    this.unsubscribers = [];
    this.callsService.leaveSession();
  }
}
```

## Step 5: Create the Call Page

Create a page component that manages the call flow:

```typescript theme={null}
// src/app/pages/call-page/call-page.component.ts
import { Component } from "@angular/core";
import { CometChatCallsService } from "../../services/cometchat-calls.service";
import { Observable } from "rxjs";

@Component({
  selector: "app-call-page",
  template: `
    <div class="call-page">
      <!-- Pre-call screen -->
      <div *ngIf="!isInCall" class="pre-call">
        <h1>CometChat Video Calls</h1>
        <p>Logged in as: {{ (user$ | async)?.name || (user$ | async)?.uid }}</p>

        <div class="join-form">
          <input
            [(ngModel)]="sessionId"
            type="text"
            placeholder="Enter Session ID"
            (keyup.enter)="startCall()"
          />
          <button (click)="startCall()" [disabled]="!sessionId">
            Join Call
          </button>
        </div>

        <p class="hint">
          Share the same Session ID with others to join the same call.
        </p>
      </div>

      <!-- In-call screen -->
      <app-call-screen
        *ngIf="isInCall"
        [sessionId]="sessionId"
        (callEnded)="endCall()"
      ></app-call-screen>
    </div>
  `,
  styles: [
    `
      .call-page {
        min-height: 100vh;
      }
      .pre-call {
        max-width: 400px;
        margin: 0 auto;
        padding: 40px 20px;
        text-align: center;
      }
      .join-form {
        margin-top: 30px;
      }
      .join-form input {
        width: 100%;
        padding: 12px;
        margin-bottom: 12px;
        border: 1px solid #ddd;
        border-radius: 8px;
        font-size: 16px;
        box-sizing: border-box;
      }
      .join-form button {
        width: 100%;
        padding: 12px;
        background-color: #6851d6;
        color: white;
        border: none;
        border-radius: 8px;
        font-size: 16px;
        cursor: pointer;
      }
      .join-form button:disabled {
        background-color: #ccc;
        cursor: not-allowed;
      }
      .hint {
        margin-top: 20px;
        color: #666;
        font-size: 14px;
      }
    `,
  ],
})
export class CallPageComponent {
  user$: Observable<any>;
  sessionId = "";
  isInCall = false;

  constructor(private callsService: CometChatCallsService) {
    this.user$ = this.callsService.user$;
  }

  startCall(): void {
    if (this.sessionId) {
      this.isInCall = true;
    }
  }

  endCall(): void {
    this.isInCall = false;
  }
}
```

## Step 6: Module Configuration

Add the components to your module:

```typescript theme={null}
// src/app/app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
import { FormsModule } from "@angular/forms";
import { RouterModule } from "@angular/router";

import { AppComponent } from "./app.component";
import { CallScreenComponent } from "./components/call-screen/call-screen.component";
import { CallPageComponent } from "./pages/call-page/call-page.component";

@NgModule({
  declarations: [AppComponent, CallScreenComponent, CallPageComponent],
  imports: [
    BrowserModule,
    FormsModule,
    RouterModule.forRoot([
      { path: "", component: CallPageComponent },
    ]),
  ],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}
```

## Standalone Components (Angular 14+)

For standalone components without NgModules:

```typescript theme={null}
// src/app/components/call-screen/call-screen.component.ts
import { Component, Input, Output, EventEmitter, OnInit, OnDestroy, ViewChild, ElementRef } from "@angular/core";
import { CommonModule } from "@angular/common";
import { CometChatCalls } from "@cometchat/calls-sdk-javascript";

@Component({
  selector: "app-call-screen",
  standalone: true,
  imports: [CommonModule],
  template: `...`, // Same template as above
})
export class CallScreenComponent implements OnInit, OnDestroy {
  // Same implementation, but import CometChatCalls directly
  // instead of using the service
}
```

## Related Documentation

For more detailed information on specific topics covered in this guide, refer to the main documentation:

* [Setup](/calls/javascript/setup) - Detailed SDK installation and initialization
* [Authentication](/calls/javascript/authentication) - Login methods and user management
* [Session Settings](/calls/javascript/session-settings) - All available call configuration options
* [Join Session](/calls/javascript/join-session) - Session joining and token generation
* [Events](/calls/javascript/events) - Complete list of event listeners
* [Actions](/calls/javascript/actions) - All available call control methods
* [Call Layouts](/calls/javascript/call-layouts) - Layout options and customization
* [Participant Management](/calls/javascript/participant-management) - Managing call participants


> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# React Integration

> CometChat Calling SDK v5 - React Integration for JavaScript

This guide walks you through integrating the CometChat Calls SDK into a React application. By the end, you'll have a working video call implementation with proper state management and lifecycle handling.

## Prerequisites

Before you begin, ensure you have:

* A CometChat account with an app created ([Sign up](https://app.cometchat.com/signup))
* Your App ID, Region, and API Key from the CometChat Dashboard
* A React project (Create React App, Vite, or similar)
* Node.js 16+ installed

## Step 1: Install the SDK

Install the CometChat Calls SDK package:

```bash theme={null}
npm install @cometchat/calls-sdk-javascript
```

## Step 2: Initialize and Login

Create a provider component to handle SDK initialization and authentication. This ensures the SDK is ready before any call components render.

```jsx theme={null}
// src/providers/CometChatCallsProvider.jsx
import { createContext, useContext, useEffect, useState } from "react";
import { CometChatCalls } from "@cometchat/calls-sdk-javascript";

const CometChatCallsContext = createContext({
  isReady: false,
  user: null,
  error: null,
});

const APP_ID = "YOUR_APP_ID";       // Replace with your App ID
const REGION = "YOUR_REGION";       // Replace with your Region (us, eu, in)
const API_KEY = "YOUR_API_KEY";     // Replace with your API Key

export function CometChatCallsProvider({ children, uid }) {
  const [isReady, setIsReady] = useState(false);
  const [user, setUser] = useState(null);
  const [error, setError] = useState(null);

  useEffect(() => {
    async function initAndLogin() {
      try {
        // Step 1: Initialize the SDK
        const initResult = await CometChatCalls.init({
          appId: APP_ID,
          region: REGION,
        });

        if (!initResult.success) {
          throw new Error("SDK initialization failed");
        }

        // Step 2: Check if already logged in
        let loggedInUser = CometChatCalls.getLoggedInUser();

        // Step 3: Login if not already logged in
        if (!loggedInUser) {
          loggedInUser = await CometChatCalls.login(uid, API_KEY);
        }

        setUser(loggedInUser);
        setIsReady(true);
      } catch (err) {
        console.error("CometChat Calls setup failed:", err);
        setError(err.message || "Setup failed");
      }
    }

    if (uid) {
      initAndLogin();
    }
  }, [uid]);

  return (
    <CometChatCallsContext.Provider value={{ isReady, user, error }}>
      {children}
    </CometChatCallsContext.Provider>
  );
}

export function useCometChatCalls() {
  return useContext(CometChatCallsContext);
}
```

## Step 3: Wrap Your App

Add the provider to your app's root component:

```jsx theme={null}
// src/App.jsx
import { CometChatCallsProvider } from "./providers/CometChatCallsProvider";
import CallPage from "./pages/CallPage";

function App() {
  // In a real app, get this from your authentication system
  const currentUserId = "cometchat-uid-1";

  return (
    <CometChatCallsProvider uid={currentUserId}>
      <CallPage />
    </CometChatCallsProvider>
  );
}

export default App;
```

## Step 4: Create the Call Component

Build a call component that handles joining, controls, and cleanup:

```jsx theme={null}
// src/components/CallScreen.jsx
import { useEffect, useRef, useState } from "react";
import { CometChatCalls } from "@cometchat/calls-sdk-javascript";
import { useCometChatCalls } from "../providers/CometChatCallsProvider";

export default function CallScreen({ sessionId, onCallEnd }) {
  const { isReady } = useCometChatCalls();
  const containerRef = useRef(null);
  
  // Call state
  const [isJoined, setIsJoined] = useState(false);
  const [isJoining, setIsJoining] = useState(false);
  const [isMuted, setIsMuted] = useState(false);
  const [isVideoOff, setIsVideoOff] = useState(false);
  const [error, setError] = useState(null);
  
  // Store unsubscribe functions for cleanup
  const unsubscribersRef = useRef([]);

  useEffect(() => {
    // Don't proceed if SDK isn't ready or container isn't mounted
    if (!isReady || !containerRef.current || !sessionId) return;

    async function joinCall() {
      setIsJoining(true);
      setError(null);

      try {
        // Register event listeners before joining
        unsubscribersRef.current = [
          CometChatCalls.addEventListener("onSessionJoined", () => {
            setIsJoined(true);
            setIsJoining(false);
          }),
          CometChatCalls.addEventListener("onSessionLeft", () => {
            setIsJoined(false);
            onCallEnd?.();
          }),
          CometChatCalls.addEventListener("onAudioMuted", () => setIsMuted(true)),
          CometChatCalls.addEventListener("onAudioUnMuted", () => setIsMuted(false)),
          CometChatCalls.addEventListener("onVideoPaused", () => setIsVideoOff(true)),
          CometChatCalls.addEventListener("onVideoResumed", () => setIsVideoOff(false)),
        ];

        // Generate a call token for this session
        const tokenResult = await CometChatCalls.generateToken(sessionId);

        // Join the call session
        const joinResult = await CometChatCalls.joinSession(
          tokenResult.token,
          {
            sessionType: "VIDEO",
            layout: "TILE",
            startAudioMuted: false,
            startVideoPaused: false,
          },
          containerRef.current
        );

        if (joinResult.error) {
          throw new Error(joinResult.error.message);
        }
      } catch (err) {
        console.error("Failed to join call:", err);
        setError(err.message || "Failed to join call");
        setIsJoining(false);
      }
    }

    joinCall();

    // Cleanup when component unmounts
    return () => {
      unsubscribersRef.current.forEach((unsub) => unsub());
      unsubscribersRef.current = [];
      CometChatCalls.leaveSession();
    };
  }, [isReady, sessionId, onCallEnd]);

  // Control handlers
  const toggleAudio = () => {
    isMuted ? CometChatCalls.unMuteAudio() : CometChatCalls.muteAudio();
  };

  const toggleVideo = () => {
    isVideoOff ? CometChatCalls.resumeVideo() : CometChatCalls.pauseVideo();
  };

  const leaveCall = () => {
    CometChatCalls.leaveSession();
  };

  // Loading state
  if (!isReady) {
    return <div className="call-loading">Initializing...</div>;
  }

  // Error state
  if (error) {
    return (
      <div className="call-error">
        <p>Error: {error}</p>
        <button onClick={() => window.location.reload()}>Retry</button>
      </div>
    );
  }

  return (
    <div className="call-screen">
      {/* Video container - SDK renders the call UI here */}
      <div 
        ref={containerRef} 
        className="call-container"
        style={{ width: "100%", height: "500px", backgroundColor: "#1a1a1a" }}
      />

      {/* Loading overlay */}
      {isJoining && (
        <div className="call-joining">Joining call...</div>
      )}

      {/* Call controls */}
      {isJoined && (
        <div className="call-controls" style={{ display: "flex", gap: "10px", padding: "16px", justifyContent: "center" }}>
          <button 
            onClick={toggleAudio}
            style={{ padding: "12px 24px", backgroundColor: isMuted ? "#dc3545" : "#28a745", color: "white", border: "none", borderRadius: "8px" }}
          >
            {isMuted ? "Unmute" : "Mute"}
          </button>
          <button 
            onClick={toggleVideo}
            style={{ padding: "12px 24px", backgroundColor: isVideoOff ? "#dc3545" : "#28a745", color: "white", border: "none", borderRadius: "8px" }}
          >
            {isVideoOff ? "Start Video" : "Stop Video"}
          </button>
          <button 
            onClick={leaveCall}
            style={{ padding: "12px 24px", backgroundColor: "#dc3545", color: "white", border: "none", borderRadius: "8px" }}
          >
            Leave Call
          </button>
        </div>
      )}
    </div>
  );
}
```

## Step 5: Use the Call Component

Create a page that uses the call component:

```jsx theme={null}
// src/pages/CallPage.jsx
import { useState } from "react";
import { useCometChatCalls } from "../providers/CometChatCallsProvider";
import CallScreen from "../components/CallScreen";

export default function CallPage() {
  const { isReady, user, error } = useCometChatCalls();
  const [sessionId, setSessionId] = useState("");
  const [isInCall, setIsInCall] = useState(false);

  if (error) {
    return <div>Error: {error}</div>;
  }

  if (!isReady) {
    return <div>Loading...</div>;
  }

  if (isInCall) {
    return (
      <CallScreen 
        sessionId={sessionId} 
        onCallEnd={() => setIsInCall(false)} 
      />
    );
  }

  return (
    <div style={{ padding: "20px", maxWidth: "400px", margin: "0 auto" }}>
      <h1>CometChat Calls</h1>
      <p>Logged in as: {user?.name || user?.uid}</p>
      
      <div style={{ marginTop: "20px" }}>
        <input
          type="text"
          placeholder="Enter Session ID"
          value={sessionId}
          onChange={(e) => setSessionId(e.target.value)}
          style={{ width: "100%", padding: "12px", marginBottom: "10px" }}
        />
        <button
          onClick={() => setIsInCall(true)}
          disabled={!sessionId}
          style={{ width: "100%", padding: "12px", backgroundColor: "#6851D6", color: "white", border: "none", borderRadius: "8px" }}
        >
          Join Call
        </button>
      </div>
    </div>
  );
}
```

## Custom Hook (Optional)

For more complex applications, extract call logic into a reusable hook:

```jsx theme={null}
// src/hooks/useCall.js
import { useState, useCallback, useRef, useEffect } from "react";
import { CometChatCalls } from "@cometchat/calls-sdk-javascript";

export function useCall() {
  const [isInCall, setIsInCall] = useState(false);
  const [isMuted, setIsMuted] = useState(false);
  const [isVideoOff, setIsVideoOff] = useState(false);
  const [participants, setParticipants] = useState([]);
  const unsubscribersRef = useRef([]);

  const joinCall = useCallback(async (sessionId, container, settings = {}) => {
    // Setup listeners
    unsubscribersRef.current = [
      CometChatCalls.addEventListener("onAudioMuted", () => setIsMuted(true)),
      CometChatCalls.addEventListener("onAudioUnMuted", () => setIsMuted(false)),
      CometChatCalls.addEventListener("onVideoPaused", () => setIsVideoOff(true)),
      CometChatCalls.addEventListener("onVideoResumed", () => setIsVideoOff(false)),
      CometChatCalls.addEventListener("onParticipantListChanged", setParticipants),
      CometChatCalls.addEventListener("onSessionLeft", () => setIsInCall(false)),
    ];

    const tokenResult = await CometChatCalls.generateToken(sessionId);
    await CometChatCalls.joinSession(
      tokenResult.token,
      { sessionType: "VIDEO", layout: "TILE", ...settings },
      container
    );
    setIsInCall(true);
  }, []);

  const leaveCall = useCallback(() => {
    CometChatCalls.leaveSession();
    unsubscribersRef.current.forEach((unsub) => unsub());
    unsubscribersRef.current = [];
    setIsInCall(false);
  }, []);

  const toggleAudio = useCallback(() => {
    isMuted ? CometChatCalls.unMuteAudio() : CometChatCalls.muteAudio();
  }, [isMuted]);

  const toggleVideo = useCallback(() => {
    isVideoOff ? CometChatCalls.resumeVideo() : CometChatCalls.pauseVideo();
  }, [isVideoOff]);

  // Cleanup on unmount
  useEffect(() => {
    return () => {
      unsubscribersRef.current.forEach((unsub) => unsub());
    };
  }, []);

  return {
    isInCall,
    isMuted,
    isVideoOff,
    participants,
    joinCall,
    leaveCall,
    toggleAudio,
    toggleVideo,
  };
}
```

## TypeScript Support

The SDK includes TypeScript definitions. Here's a typed version of the provider:

```tsx theme={null}
// src/providers/CometChatCallsProvider.tsx
import { createContext, useContext, useEffect, useState, ReactNode } from "react";
import { CometChatCalls } from "@cometchat/calls-sdk-javascript";

interface User {
  uid: string;
  name: string;
  avatar?: string;
}

interface CometChatCallsContextType {
  isReady: boolean;
  user: User | null;
  error: string | null;
}

const CometChatCallsContext = createContext<CometChatCallsContextType>({
  isReady: false,
  user: null,
  error: null,
});

interface ProviderProps {
  children: ReactNode;
  uid: string;
}

export function CometChatCallsProvider({ children, uid }: ProviderProps) {
  // ... same implementation as above
}

export function useCometChatCalls(): CometChatCallsContextType {
  return useContext(CometChatCallsContext);
}
```

## Related Documentation

For more detailed information on specific topics covered in this guide, refer to the main documentation:

* [Setup](/calls/javascript/setup) - Detailed SDK installation and initialization
* [Authentication](/calls/javascript/authentication) - Login methods and user management
* [Session Settings](/calls/javascript/session-settings) - All available call configuration options
* [Join Session](/calls/javascript/join-session) - Session joining and token generation
* [Events](/calls/javascript/events) - Complete list of event listeners
* [Actions](/calls/javascript/actions) - All available call control methods
* [Call Layouts](/calls/javascript/call-layouts) - Layout options and customization
* [Participant Management](/calls/javascript/participant-management) - Managing call participants


> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Vue Integration

> CometChat Calling SDK v5 - Vue Integration for JavaScript

This guide walks you through integrating the CometChat Calls SDK into a Vue.js application. By the end, you'll have a working video call implementation with proper state management and lifecycle handling.

## Prerequisites

Before you begin, ensure you have:

* A CometChat account with an app created ([Sign up](https://app.cometchat.com/signup))
* Your App ID, Region, and API Key from the CometChat Dashboard
* A Vue 3 project (Vite, Vue CLI, or Nuxt)
* Node.js 16+ installed

## Step 1: Install the SDK

Install the CometChat Calls SDK package:

```bash theme={null}
npm install @cometchat/calls-sdk-javascript
```

## Step 2: Create a Composable for SDK Management

Create a composable that handles initialization, login, and provides reactive state:

```javascript theme={null}
// src/composables/useCometChatCalls.js
import { ref, readonly } from "vue";
import { CometChatCalls } from "@cometchat/calls-sdk-javascript";

const APP_ID = "YOUR_APP_ID";       // Replace with your App ID
const REGION = "YOUR_REGION";       // Replace with your Region (us, eu, in)
const API_KEY = "YOUR_API_KEY";     // Replace with your API Key

// Shared state across all components
const isReady = ref(false);
const user = ref(null);
const error = ref(null);
const isInitializing = ref(false);

export function useCometChatCalls() {
  /**
   * Initialize the SDK and login the user.
   * Call this once when your app starts or when the user authenticates.
   */
  async function initAndLogin(uid) {
    if (isInitializing.value || isReady.value) return;
    
    isInitializing.value = true;
    error.value = null;

    try {
      // Step 1: Initialize the SDK
      const initResult = await CometChatCalls.init({
        appId: APP_ID,
        region: REGION,
      });

      if (!initResult.success) {
        throw new Error("SDK initialization failed");
      }

      // Step 2: Check if already logged in
      let loggedInUser = CometChatCalls.getLoggedInUser();

      // Step 3: Login if not already logged in
      if (!loggedInUser) {
        loggedInUser = await CometChatCalls.login(uid, API_KEY);
      }

      user.value = loggedInUser;
      isReady.value = true;
    } catch (err) {
      console.error("CometChat Calls setup failed:", err);
      error.value = err.message || "Setup failed";
    } finally {
      isInitializing.value = false;
    }
  }

  /**
   * Logout the current user and reset state.
   */
  async function logout() {
    try {
      await CometChatCalls.logout();
      user.value = null;
      isReady.value = false;
    } catch (err) {
      console.error("Logout failed:", err);
    }
  }

  return {
    // State (readonly to prevent external mutations)
    isReady: readonly(isReady),
    user: readonly(user),
    error: readonly(error),
    isInitializing: readonly(isInitializing),
    
    // Methods
    initAndLogin,
    logout,
  };
}
```

## Step 3: Initialize in App.vue

Initialize the SDK when your app mounts:

```vue theme={null}
<!-- src/App.vue -->
<template>
  <div id="app">
    <div v-if="error" class="error">
      Error: {{ error }}
    </div>
    <div v-else-if="!isReady" class="loading">
      Loading...
    </div>
    <router-view v-else />
  </div>
</template>

<script setup>
import { onMounted } from "vue";
import { useCometChatCalls } from "./composables/useCometChatCalls";

const { isReady, error, initAndLogin } = useCometChatCalls();

onMounted(() => {
  // In a real app, get this from your authentication system
  const currentUserId = "cometchat-uid-1";
  initAndLogin(currentUserId);
});
</script>
```

## Step 4: Create the Call Component

Build a call component with proper lifecycle management:

```vue theme={null}
<!-- src/components/CallScreen.vue -->
<template>
  <div class="call-screen">
    <!-- Video container - SDK renders the call UI here -->
    <div 
      ref="callContainer" 
      class="call-container"
    />

    <!-- Loading overlay -->
    <div v-if="isJoining" class="call-joining">
      Joining call...
    </div>

    <!-- Error message -->
    <div v-if="callError" class="call-error">
      <p>Error: {{ callError }}</p>
      <button @click="$emit('callEnd')">Go Back</button>
    </div>

    <!-- Call controls -->
    <div v-if="isJoined" class="call-controls">
      <button 
        @click="toggleAudio" 
        :class="{ active: !isMuted, muted: isMuted }"
      >
        {{ isMuted ? "Unmute" : "Mute" }}
      </button>
      <button 
        @click="toggleVideo" 
        :class="{ active: !isVideoOff, muted: isVideoOff }"
      >
        {{ isVideoOff ? "Start Video" : "Stop Video" }}
      </button>
      <button @click="leaveCall" class="leave-btn">
        Leave Call
      </button>
    </div>
  </div>
</template>

<script setup>
import { ref, onMounted, onUnmounted } from "vue";
import { CometChatCalls } from "@cometchat/calls-sdk-javascript";

// Props
const props = defineProps({
  sessionId: {
    type: String,
    required: true,
  },
});

// Emits
const emit = defineEmits(["callEnd"]);

// Refs
const callContainer = ref(null);
const isJoined = ref(false);
const isJoining = ref(false);
const isMuted = ref(false);
const isVideoOff = ref(false);
const callError = ref(null);
const unsubscribers = ref([]);

/**
 * Join the call session.
 * This generates a token and connects to the call.
 */
async function joinCall() {
  if (!callContainer.value) return;
  
  isJoining.value = true;
  callError.value = null;

  try {
    // Register event listeners before joining
    unsubscribers.value = [
      CometChatCalls.addEventListener("onSessionJoined", () => {
        isJoined.value = true;
        isJoining.value = false;
      }),
      CometChatCalls.addEventListener("onSessionLeft", () => {
        isJoined.value = false;
        emit("callEnd");
      }),
      CometChatCalls.addEventListener("onAudioMuted", () => {
        isMuted.value = true;
      }),
      CometChatCalls.addEventListener("onAudioUnMuted", () => {
        isMuted.value = false;
      }),
      CometChatCalls.addEventListener("onVideoPaused", () => {
        isVideoOff.value = true;
      }),
      CometChatCalls.addEventListener("onVideoResumed", () => {
        isVideoOff.value = false;
      }),
    ];

    // Generate a call token for this session
    const tokenResult = await CometChatCalls.generateToken(props.sessionId);

    // Join the call session
    const joinResult = await CometChatCalls.joinSession(
      tokenResult.token,
      {
        sessionType: "VIDEO",
        layout: "TILE",
        startAudioMuted: false,
        startVideoPaused: false,
      },
      callContainer.value
    );

    if (joinResult.error) {
      throw new Error(joinResult.error.message);
    }
  } catch (err) {
    console.error("Failed to join call:", err);
    callError.value = err.message || "Failed to join call";
    isJoining.value = false;
  }
}

/**
 * Toggle microphone mute state.
 */
function toggleAudio() {
  if (isMuted.value) {
    CometChatCalls.unMuteAudio();
  } else {
    CometChatCalls.muteAudio();
  }
}

/**
 * Toggle camera on/off state.
 */
function toggleVideo() {
  if (isVideoOff.value) {
    CometChatCalls.resumeVideo();
  } else {
    CometChatCalls.pauseVideo();
  }
}

/**
 * Leave the current call session.
 */
function leaveCall() {
  CometChatCalls.leaveSession();
}

/**
 * Cleanup event listeners and leave call.
 */
function cleanup() {
  unsubscribers.value.forEach((unsub) => unsub());
  unsubscribers.value = [];
  CometChatCalls.leaveSession();
}

// Lifecycle hooks
onMounted(() => {
  joinCall();
});

onUnmounted(() => {
  cleanup();
});
</script>

<style scoped>
.call-screen {
  display: flex;
  flex-direction: column;
  height: 100vh;
}

.call-container {
  flex: 1;
  background-color: #1a1a1a;
  min-height: 400px;
}

.call-controls {
  display: flex;
  justify-content: center;
  gap: 12px;
  padding: 16px;
  background-color: #2a2a2a;
}

.call-controls button {
  padding: 12px 24px;
  border: none;
  border-radius: 8px;
  font-size: 14px;
  cursor: pointer;
  transition: background-color 0.2s;
}

.call-controls button.active {
  background-color: #28a745;
  color: white;
}

.call-controls button.muted {
  background-color: #dc3545;
  color: white;
}

.call-controls .leave-btn {
  background-color: #dc3545;
  color: white;
}

.call-joining,
.call-error {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  background: rgba(0, 0, 0, 0.8);
  color: white;
  padding: 20px;
  border-radius: 8px;
  text-align: center;
}
</style>
```

## Step 5: Create the Call Page

Create a page that manages the call flow:

```vue theme={null}
<!-- src/views/CallPage.vue -->
<template>
  <div class="call-page">
    <!-- Pre-call screen -->
    <div v-if="!isInCall" class="pre-call">
      <h1>CometChat Video Calls</h1>
      <p>Logged in as: {{ user?.name || user?.uid }}</p>

      <div class="join-form">
        <input
          v-model="sessionId"
          type="text"
          placeholder="Enter Session ID"
          @keyup.enter="startCall"
        />
        <button 
          @click="startCall" 
          :disabled="!sessionId"
        >
          Join Call
        </button>
      </div>

      <p class="hint">
        Share the same Session ID with others to join the same call.
      </p>
    </div>

    <!-- In-call screen -->
    <CallScreen
      v-else
      :session-id="sessionId"
      @call-end="endCall"
    />
  </div>
</template>

<script setup>
import { ref } from "vue";
import { useCometChatCalls } from "../composables/useCometChatCalls";
import CallScreen from "../components/CallScreen.vue";

const { user } = useCometChatCalls();

const sessionId = ref("");
const isInCall = ref(false);

function startCall() {
  if (sessionId.value) {
    isInCall.value = true;
  }
}

function endCall() {
  isInCall.value = false;
}
</script>

<style scoped>
.call-page {
  min-height: 100vh;
}

.pre-call {
  max-width: 400px;
  margin: 0 auto;
  padding: 40px 20px;
  text-align: center;
}

.join-form {
  margin-top: 30px;
}

.join-form input {
  width: 100%;
  padding: 12px;
  margin-bottom: 12px;
  border: 1px solid #ddd;
  border-radius: 8px;
  font-size: 16px;
}

.join-form button {
  width: 100%;
  padding: 12px;
  background-color: #6851D6;
  color: white;
  border: none;
  border-radius: 8px;
  font-size: 16px;
  cursor: pointer;
}

.join-form button:disabled {
  background-color: #ccc;
  cursor: not-allowed;
}

.hint {
  margin-top: 20px;
  color: #666;
  font-size: 14px;
}
</style>
```

## Call Composable (Optional)

For reusable call logic across multiple components:

```javascript theme={null}
// src/composables/useCall.js
import { ref, onUnmounted } from "vue";
import { CometChatCalls } from "@cometchat/calls-sdk-javascript";

export function useCall() {
  const isInCall = ref(false);
  const isMuted = ref(false);
  const isVideoOff = ref(false);
  const participants = ref([]);
  const unsubscribers = ref([]);

  async function joinCall(sessionId, container, settings = {}) {
    unsubscribers.value = [
      CometChatCalls.addEventListener("onAudioMuted", () => { isMuted.value = true; }),
      CometChatCalls.addEventListener("onAudioUnMuted", () => { isMuted.value = false; }),
      CometChatCalls.addEventListener("onVideoPaused", () => { isVideoOff.value = true; }),
      CometChatCalls.addEventListener("onVideoResumed", () => { isVideoOff.value = false; }),
      CometChatCalls.addEventListener("onParticipantListChanged", (list) => { participants.value = list; }),
      CometChatCalls.addEventListener("onSessionLeft", () => { isInCall.value = false; }),
    ];

    const tokenResult = await CometChatCalls.generateToken(sessionId);
    await CometChatCalls.joinSession(
      tokenResult.token,
      { sessionType: "VIDEO", layout: "TILE", ...settings },
      container
    );
    isInCall.value = true;
  }

  function leaveCall() {
    CometChatCalls.leaveSession();
    cleanup();
  }

  function toggleAudio() {
    isMuted.value ? CometChatCalls.unMuteAudio() : CometChatCalls.muteAudio();
  }

  function toggleVideo() {
    isVideoOff.value ? CometChatCalls.resumeVideo() : CometChatCalls.pauseVideo();
  }

  function cleanup() {
    unsubscribers.value.forEach((unsub) => unsub());
    unsubscribers.value = [];
    isInCall.value = false;
  }

  onUnmounted(() => {
    cleanup();
  });

  return {
    isInCall,
    isMuted,
    isVideoOff,
    participants,
    joinCall,
    leaveCall,
    toggleAudio,
    toggleVideo,
  };
}
```

## Vue 2 Support

For Vue 2 projects using the Options API, see the [Vue 2 migration guide](https://v3-migration.vuejs.org/) or use the `@vue/composition-api` package to use the Composition API in Vue 2.

## Related Documentation

For more detailed information on specific topics covered in this guide, refer to the main documentation:

* [Setup](/calls/javascript/setup) - Detailed SDK installation and initialization
* [Authentication](/calls/javascript/authentication) - Login methods and user management
* [Session Settings](/calls/javascript/session-settings) - All available call configuration options
* [Join Session](/calls/javascript/join-session) - Session joining and token generation
* [Events](/calls/javascript/events) - Complete list of event listeners
* [Actions](/calls/javascript/actions) - All available call control methods
* [Call Layouts](/calls/javascript/call-layouts) - Layout options and customization
* [Participant Management](/calls/javascript/participant-management) - Managing call participants
